/*
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 */
package fodaat;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;
import java.util.Vector;
import org.sat4j.core.Vec;
import org.sat4j.core.VecInt;
import org.sat4j.specs.ContradictionException;
import org.sat4j.specs.ISolver;
import org.sat4j.specs.IVec;
import org.sat4j.specs.IVecInt;

public class Checkmark extends FodaPA {
    public static final String NAME = "checkmark";
    /**
     * Creates a new <code>NIL</code> instance.
     *
     */
    public Checkmark() {
	this.size = 1;
    }
    public boolean equals(Object other) {
	if (other instanceof Checkmark) {
	    return true;
	} else {
	    return false;
	}
    }

    /**
     * Describe <code>getClauses</code> method here.
     *
     * @param arrayList an <code>ArrayList</code> value
     * @return an <code>IVec</code> value
     */
    public final IVec<IVecInt> getClauses(LiteralMap idMap, boolean full) {
	IVec<IVecInt> clauses = new Vec<IVecInt>();	
	if (full) {
	    for (String varName: idMap.keySet()) {
		if ( varName.indexOf(AUX_VAR_PREFIX)<0 ) {		    
		    IVecInt clause = new VecInt(1);
		    clause.push(-( idMap.getLiteral(varName) ));
		    clauses.push(clause);
		}

	    }
	}
	return clauses;
    }
    // public void addClauses(ISolver solver, HashMap<String,Integer> idMap, boolean full ) 
    // 	throws ContradictionException {
    // 	solver.addAllClauses(getClauses(idMap,full));
    // }
  
    /**
     * Describe <code>reduce</code> method here.
     *
     * @return a <code>ComboFodaPABool</code> value
     */
    public FodaPA reduce() {
	return this;
    }

    /**
     * Describe <code>toString</code> method here.
     *
     * @return a <code>String</code> value
     */
    public final String toString() {
	return "tick";
    }

    /**
     * Describe <code>denotational</code> method here.
     *
     * @return a <code>Set</code> value
     */
    public final Set<Product> denotational() {
	Set<Product> s = new HashSet<Product>();
	Product p = new Product();
	s.add(p);
	return s;
    }
 }
