/*
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 */
package fodaat;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;
import java.util.Vector;
import org.sat4j.core.Vec;
import org.sat4j.core.VecInt;
import org.sat4j.specs.ContradictionException;
import org.sat4j.specs.ISolver;
import org.sat4j.specs.IVec;
import org.sat4j.specs.IVecInt;

public class Nil extends FodaPA {
    public static final String NAME = "nil";
    /**
     * Creates a new <code>NIL</code> instance.
     *
     */
    public Nil() {
	this.size = 1;
    }

    public IVec<IVecInt> getClauses(LiteralMap idMap, boolean full) {
	IVec<IVecInt> vec = new Vec();	
	IVecInt vecInt = new VecInt();
	vec.push(vecInt);
	return vec;
    }
    	
    // public final void addClauses(ISolver solver, HashMap<String,Integer> idMap, boolean full) 
    // 	throws ContradictionException{
    // 	solver.addAllClauses(getClauses(idMap,full));
    // }
    
    public boolean equals(Object other) {
	if (other instanceof Nil) {
	    return true;
	} else {
	    return false;
	}
    }
    /**
     * Describe <code>reduce</code> method here.
     *
     * @return a <code>ComboFodaPABool</code> value
     */
    public FodaPA reduce() {
	return this;
    }
    public boolean isNil() {
	return true;
    }

    /**
     * Describe <code>toString</code> method here.
     *
     * @return a <code>String</code> value
     */
    public final String toString() {
	return "nil";
    }

    /**
     * Describe <code>denotational</code> method here.
     *
     * @return a <code>Set</code> value
     */
    public final Set<Product> denotational() {
	return new HashSet<Product>();
    }
    
}
