/*
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 */
package fodaat;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.HashMap;
import org.apache.commons.lang3.StringUtils;
import org.sat4j.core.Vec;
import org.sat4j.core.VecInt;
import org.sat4j.minisat.SolverFactory;
import org.sat4j.specs.IProblem;
import org.sat4j.specs.ISolver;
import org.sat4j.specs.IVec;
import org.sat4j.specs.IVecInt;

/**
 * Describe class SatSolver here.
 *
 *
 * Created: Wed Nov 28 14:35:17 2012
 *
 * @author <a href="mailto:luis@kimba.mat.ucm.es"></a>
 * @version $Id: PrSat.java,v 1.2 2013/05/14 09:22:28 luis Exp $
 */
public class PrSat {

    private static void printMap(HashMap<String,Integer> idMap) {
	for (String str : idMap.keySet()) {
	    System.out.print(String.format("(%1s,%1d)",str, idMap.get(str)));
	}
	
    }
    public static void main(String [] args) throws Exception {
	BufferedReader in = new BufferedReader(new FileReader(args[0]));
	int numVars = Integer.parseInt(args[1]);
	

	String line = in.readLine();
	IVec<IVecInt> vec = new Vec<IVecInt>();
	int pos=0;
	while (line!=null) {
	    System.out.print(pos+":  ");
	    String [] atoms = line.split(",");
	    IVecInt clause = new VecInt(atoms.length);
	    for (String a: atoms) {
		System.out.print(a+" ");
		clause.push(Integer.parseInt(a));
	    }
	    System.out.println();
	    vec.push(clause);
	    line = in.readLine();
	    pos ++;
	}
	int ini = 11;
	for (int i = 15;  i>=14 ; i--) {
	    System.out.print(i+"...");
	    ISolver solver = SolverFactory.newDefault();
	    for (int j = 0; j < ini ; j++) {
		solver.addClause(vec.get(j));
	    }

	    solver.newVar(numVars);
	    for (int j=15; j>=i; j--) {
		solver.addClause(vec.get(j));
	    }
	    System.out.print("thinking....");
	    if (solver.isSatisfiable()) {
		System.out.println("YES");
	    } else {
		System.out.println("NO");
	    }
	}
    }
}
