/*
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 */
/**
 * Describe class TestAxiom here.
 *
 *
 * Created: Fri Apr 19 13:41:41 2013
 *
 * @author <a href="mailto:luis@luis-HP3">Luis Llana</a>
 * @version $Id: TestAxiom.java,v 1.2 2013/05/14 09:22:29 luis Exp $
 */
 
package fodaat; 

import java.io.File;
import java.util.Date;
import org.apache.log4j.PropertyConfigurator;

public class TestAxiom {
        private static long computeReductions(FodaPA fodaPA) {
	boolean cont = true;
	Date start = new Date();
	FodaPA newTerm = fodaPA;
	int nr = 0;
	while (cont) {
	    newTerm = newTerm.reduce();
	    cont = (nr!=FodaPA.numReductions);
	    nr = FodaPA.numReductions;
	    //System.out.println(String.format("--------------------------------\n%1d:%2s:%3d:%4s", nr, newTerm.toString(), newTerm.getSize(), newTerm.getClass().getName()));
	    //System.out.print(String.format("%1d..",nred));
	}
	// System.out.println(newTerm);
	System.out.print(String.format(" %s",!newTerm.isNil()));
	Date end = new Date();
	// System.out.print("  "+nr);
	return end.getTime()-start.getTime();
    }
	
    public static void main(String [] args) throws Exception {
	File file = new File(args[0]);
	boolean axStrict = false;
	if (args.length>1) {
	    axStrict = Boolean.parseBoolean(args[1]);
	}
	FodaPA.setAxStrict(axStrict);
	FodaPA fodaPA = FodaPA.readXML(file);
	PropertyConfigurator.configure("log4j.properties");
	System.out.println("Término:"+fodaPA+":"+fodaPA.getClass().getName());
	// fodaPA = fodaPA.reduceAll();
	// System.out.println("Término:"+fodaPA+":"+fodaPA.getClass().getName());
	
	System.out.print(args[0]);
	long time = computeReductions(fodaPA);
	System.out.println("  "+time);
	//System.out.println();
    }


}
