/*
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 */

package fodaat;

import java.io.File;
import java.util.Date;
import java.util.Set;

public class TestDenotational extends Thread{
    private FodaPA term;
    boolean strict;
    long timeout;
    Set<Product> products;

    TestDenotational(FodaPA term, boolean strict, long timeout) {
	this.term = term;
	this.strict = strict;
	this.products = null;
	this.timeout = timeout;
    }

    public void run() {
	FodaPA.setAxStrict(this.strict);
	products = term.denotational();
    }

    public void test() throws InterruptedException{
	Date start = new Date();
	this.start();
	try {
	    this.join(timeout);
	    Date end = new Date();
	    long time = end.getTime() - start.getTime();
	    if (products!=null) {
  	      System.out.println(String.format("%d %d ",time, products.size()));
	    } else {
  	      System.out.println(String.format("%d - ",time));
	    }
	} catch(InterruptedException e) {
	    Date end = new Date();
	    long time = end.getTime() - start.getTime();
	    System.out.println(String.format("%d - ",time));	    
	}	    
    }
    public static void main(String [] args) throws Exception {
	    File file = new File(args[0]);
	    boolean strict = false;
	    if (args.length>=2) {
		strict = Boolean.parseBoolean(args[1]);
	    }
	    long timeout = 0;
	    if (args.length>=3) {
		timeout = Long.parseLong(args[2]);
	    }
	    System.out.print(String.format("%s %b ", args[0], strict));
	    FodaPA fodaPA = FodaPA.readXML(file);
	    TestDenotational test = new TestDenotational(fodaPA, strict, timeout);
	    test.test();
	    System.exit(0);
    }
}